<?php

namespace Shavshukov\EventAppBase\FileReaders;

use React\Stream\WritableStreamInterface;
use React\Promise;

class BlockingFileReader implements FileReaderInterface
{
    /**
     * {@inheritDoc}
     */
    public function getContents(string $fileName): Promise\PromiseInterface
    {
        return new Promise\Promise(function (\Closure $resolve) use ($fileName) {
            $contents = file_get_contents($fileName);
            $resolve($contents);
        });
    }
    
    /**
     * {@inheritDoc}
     */
    public function pipeContents(string $fileName, WritableStreamInterface $writeStream, array $options = [])
    {
        $contents = file_get_contents($fileName);
        
        if (!$writeStream->isWritable()) {
            throw new \Exception("Write stream is not writeable!");
        }

        $writeStream->write($contents);
        $writeStream->end();
    }
    
    /**
     * {@inheritDoc}
     */
    public function asResponseArgument(string $fileName, array $options = [])
    {
        return file_get_contents($fileName);
    }
}
