<?php

namespace Shavshukov\EventAppBase\Interfaces;

interface ValidationResultInterface
{
    
    /**
     * Check whether all mandatory fields are present
     * 
     * @return bool
     */
    public function isValid(): bool;
 
    /**
     * Get invalid fields, which are mandatory and not present
     * 
     * @return array
     */
    public function getInvalidFields(): array;
    
    /**
     * Get the object that was validated
     * 
     * @return \Shavshukov\EventAppBase\Interfaces\ValidatableInterface
     */
    public function getSubject(): ValidatableInterface;
    
}
