<?php

namespace Shavshukov\EventAppBase\Model;

use Shavshukov\EventAppBase\Interfaces\ValidationResultInterface;

trait ModelValidationTrait
{
    /**
     * Mandatory fields
     *
     * @var array|null
     */
    protected $mandatoryFields;

    /**
     * Validate the object
     * 
     * @return \Shavshukov\EventAppBase\Interfaces\ValidationResultInterface
     */
    public function validate(): ValidationResultInterface
    {
        $notFoundFields = [];
        
        if ($this->mandatoryFields !== null) {
            foreach ($this->mandatoryFields as $path) {
                if (!$this->has($path)) {
                    $notFoundFields[] = $path;
                }
            }
        }
        
        return new ValidationResult($this, $notFoundFields);
    }
    
}
