<?php

namespace Shavshukov\EventAppBase\Model;

use Symfony\Component\Yaml\Yaml;

class YamlModel extends StorableModel
{
    
    /**
     * Flags for Yaml::parse
     *
     * @var int
     */
    protected $parseFlags = 0;
    
    /**
     * Options for Yaml::dump
     *
     * @var type 
     */
    protected $dumpOptions = [
        'inline' => 2,
        'indent' => 4,
        'flags' => 0
    ];

    /**
     * Get YamlModel from string
     * 
     * @param string $yaml
     * @return \static
     */
    public static function from(string $yaml)
    {
        $model = new static();
        $model->source = $yaml;
        $model->setDataAfterSourceChanged(true);
        return $model;
    }
    
    /**
     * {@inheritDoc}
     */
    protected function decode(): array
    {
        return Yaml::parse($this->source);
    }

    /**
     * {@inheritDoc}
     */
    protected function encode()
    {
        return Yaml::dump($this->data, $this->dumpOptions['inline'], $this->dumpOptions['indent'], $this->dumpOptions['flags']);
    }

}